# Configuration file local to this node

{ config, pkgs, ... }:

{
  # Use the systemd-boot EFI boot loader.
  boot.loader.systemd-boot.enable = true;
  boot.loader.timeout = 20;
  boot.loader.efi.canTouchEfiVariables = true;

  networking.hostName = "cariacou";

  networking.interfaces.eno1.useDHCP = false;
  networking.interfaces.eno1.ipv4.addresses = [
    {
      address = "192.168.1.21";
      prefixLength = 24;
    }
  ];
  networking.interfaces.eno1.ipv6.addresses = [
    {
      address = "2a01:e0a:c:a720::21";
      prefixLength = 64;
    }
  ];

  networking.wireguard.interfaces.wg0 = {
    ips = [ "10.42.0.21/16" ];
    listenPort = 33721;
  };

  # Enable netdata monitoring
  services.netdata.enable = true;
}
