#!/usr/bin/env bash

cd $(dirname $0)

if [ -z "$@" ]; then
	NIXHOSTLIST=$(ls node | grep -v '\.site\.')
else
	NIXHOSTLIST="$@"
fi

for NIXHOST in $NIXHOSTLIST; do
	NIXHOST=${NIXHOST%.*}

	if [ -z "$SSH_USER" ]; then
		SSH_DEST=$NIXHOST
	else
		SSH_DEST=$SSH_USER@$NIXHOST
	fi

	echo "==== DOING $NIXHOST ===="

	ssh -F ssh_config $SSH_DEST sudo nix-channel --add https://nixos.org/channels/nixos-21.11 nixos
	ssh -F ssh_config $SSH_DEST sudo nix-channel --update
	ssh -F ssh_config $SSH_DEST sudo nixos-rebuild boot

	echo "Please reboot node manually to activate upgraded system:"
	echo "$ ssh -F ssh_config $SSH_DEST sudo reboot"
done
